#include "libtest.h"
#include "../server/common.h"
#include <QDebug>
#include <QThread>

LibTest::LibTest()
{
    qDebug() << Q_FUNC_INFO;
}

int LibTest::dissection(QString path, DISSECTION_PROGRESS_CALLBACK funciton)
{
    qDebug() << Q_FUNC_INFO << path/* << QThread::currentThreadId()*/;

    FileInfo info;
    info.type = Normal;
    info.detail = "wubw test dissection path";
    funciton(1, 0.5, &info);

    return 1;
}

int LibTest::dissection(int taskId, DISSECTION_PROGRESS_CALLBACK funciton)
{
    qDebug() << Q_FUNC_INFO << taskId/* << QThread::currentThreadId()*/;

    FileInfo info;
    info.type = Suspicious;
    info.detail = "wubw test dissection path";
    funciton(2, 0.3, &info);

    return 2;
}

bool LibTest::setDissectionState(int taskId, State state)
{
    qDebug() << Q_FUNC_INFO << taskId << state/* << QThread::currentThreadId()*/;

    return 1;
}

VersionInfo LibTest::currentVersion()
{
    qDebug() << Q_FUNC_INFO /*<< QThread::currentThreadId()*/;

    VersionInfo info;
    info.version = "1.0.0";
    info.detail = "wubw test currentVersion";
    info.time = 190000000;

    return info;
}

void LibTest::check(CHECK_CALLBACK function)
{
    qDebug() << Q_FUNC_INFO /*<< QThread::currentThreadId()*/;

    VersionInfo info;
    info.version = "1.0.1";
    info.detail = "wubw test check";
    info.time = 190011001;
    function(&info);
}

void LibTest::update(UPATE_PROGRESS_CALLBACK function)
{
    qDebug() << Q_FUNC_INFO /*<< QThread::currentThreadId()*/;

    VersionInfo info;
    info.version = "1.0.2";
    info.detail = "wubw test update";
    info.time = 190008801;
    function(0.81, &info);
}
