#include "loadlib.h"
#include <QDebug>
#include "dbussecuritycenterservice.h"
loadLib::loadLib(DBusSecurityCenterService *inter, QString engineType, QObject *parent)
    : QObject(parent)
    , m_nEngineType(engineType)//根据引擎类型去加载不同的插件(so)
{
    m_interface = inter;

    m_thread.setObjectName("loadLibThread");
    moveToThread(&m_thread);
    m_thread.start();

    connect(m_interface, &DBusSecurityCenterService::requestDissectionId, this, &loadLib::dissectionId);
    connect(m_interface, &DBusSecurityCenterService::requestDissectionPath, this, &loadLib::dissectionPath);
    connect(m_interface, &DBusSecurityCenterService::requestCheck, this, &loadLib::check);
    connect(m_interface, &DBusSecurityCenterService::requestUpdate, this, &loadLib::update);
}

void loadLib::dissectionId(int processId)
{
    qDebug() << Q_FUNC_INFO << processId << QThread::currentThreadId() << m_nEngineType;
#if use_libTest
    m_libTest.dissection(processId, &m_interface->dissectionProgress);
#endif
}

void loadLib::dissectionPath(QString path)
{
    qDebug() << Q_FUNC_INFO << path << QThread::currentThreadId() << m_nEngineType;
#if use_libTest
    m_libTest.dissection(path, &m_interface->dissectionProgress);
#endif
}

void loadLib::check()
{
    qDebug() << Q_FUNC_INFO << QThread::currentThreadId() << m_nEngineType;
#if use_libTest
    m_libTest.check(m_interface->checkFinished);
#endif
}

void loadLib::update()
{
    qDebug() << Q_FUNC_INFO << QThread::currentThreadId() << m_nEngineType;
#if use_libTest
    m_libTest.update(m_interface->updateProgress);
#endif
}

#if use_libTest
LibTest *loadLib::getLibTest()
{
    return &m_libTest;
}
#endif
