#ifndef LOADLIB_H
#define LOADLIB_H

#include <QObject>
#include <QThread>

#define use_libTest 1

#if use_libTest
#include "../libTest/libtest.h"
#endif
class DBusSecurityCenterService;

class loadLib : public QObject
{
    Q_OBJECT
public:
    loadLib(DBusSecurityCenterService *inter = nullptr, QString engineType = "", QObject *parent = nullptr);

    void loadEngine();

    /*!
     * \brief 扫描进程
     * \param processId
     * \return 扫描结果
     */
    void dissectionId(int processId);

    /*!
     * \brief 扫描文件
     * \param path
     * \return 扫描结果
     */
    void dissectionPath(QString path);

    /*!
     * \brief 检查病毒库版本（是否有更新等），传⼊的是回调函数，在检查结束后调⽤ : 回调函数返回后通知病毒库当前版本信息
     * \return 返回病毒库当前版本信息
     */
    void check();

    /*!
     * \brief 更新病毒库，传⼊的是回调函数，在检查结束后调⽤ : 回调函数返回后通知update状态
     */
    void update();

#if use_libTest
    LibTest* getLibTest();
#endif

private:
    QThread m_thread;
#if use_libTest
    LibTest m_libTest;
#endif
    DBusSecurityCenterService *m_interface;
    QString m_nEngineType;
};

#endif // LOADLIB_H
