#ifndef NETLICKSOCKET_H
#define NETLICKSOCKET_H

#include <QObject>
#include <QThread>
#include <stdio.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <string.h>
#include <linux/netlink.h>
#include <stdint.h>
#include <unistd.h>
#include <errno.h>

#define NETLINK_TEST    30
#define USER_PORT    100
#define MAX_PLOAD    125
#define MSG_LEN        10240

typedef struct _user_msg_info
{
    struct nlmsghdr hdr;
    char  msg[MSG_LEN];
} user_msg_info;

class NetlinkSocket : public QThread
{
    Q_OBJECT
public:
    explicit NetlinkSocket(QObject *parent = nullptr);
    ~NetlinkSocket();

    int sendMsg(char *name, int pid, int value);

signals:

public slots:

private:
    void init();
    ssize_t RioReadn(int fd, void* userbuf, size_t n);
    void run() override;

private:
//    fd_set  m_readfds;
    struct timeval m_timeout;
    struct nlmsghdr *m_nlh;
    int m_sockfd = -1;
    user_msg_info u_info;
    struct sockaddr_nl m_saddr, m_daddr;
    socklen_t m_len;
    char sendData[1024];
};

#endif // NETLICKSOCKET_H
