/*
 * Copyright (C) 2019 ~ 2019 Deepin Technology Co., Ltd.
 *
 * Author:     wubowen <wubowen_cm@deepin.com>
 *
 * Maintainer: wubowen <wubowen_cm@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#pragma once

#include "analysisapp_adaptor.h"
#include "getpiddetailname.h"
#include "com_deepin_defender_analysisapp.h"
#include "types/defenderprocessinfo.h"
#include "types/defenderprocesslist.h"
#include "com_deepin_dde_daemon_launcherd.h"

#include <QObject>

using Launcherd = com::deepin::dde::daemon::Launcher;

class OperateDBusData : public QObject
{
    Q_OBJECT
public:
    explicit OperateDBusData(QObject *parent = nullptr);

    void updateLauncherList();
    QDBusPendingReply<LauncherItemInfoList> getLauncherList();

Q_SIGNALS:

public Q_SLOTS:
    void StartApp();
    void ExitApp();
    QString getProcessEnvironmentVariable(int pid, QString environmentName = "GIO_LAUNCHED_DESKTOP_FILE");

private:
    AnalysisappAdaptor *m_adaptor;
    GetPidDetailName *m_data;
    Launcherd *m_launcherInter;
    LauncherItemInfoList m_allApplist;//用于获取Launcher里面取出来的全部应用list
};
