QT += core gui dbus dtkwidget

greaterThan(QT_MAJOR_VERSION, 4): QT += widgets

TARGET = deepin-defender-autostart
TEMPLATE = app
CONFIG += c++11 link_pkgconfig
PKGCONFIG += dframeworkdbus

SOURCES += \
    main.cpp \
    operatedbusdata.cpp \
    window/modules/startup/startupmonitordialog.cpp \
    window/modules/startup/startupmonitor.cpp \
    window/modules/startup/dbustartmanager.cpp

HEADERS += \
    operatedbusdata.h \
    common.h \
    window/modules/startup/startupmonitordialog.h \
    window/modules/startup/startupmonitor.h \
    window/modules/startup/dbustartmanager.h

dbus.files = com.deepin.defender.autostart.xml

DBUS_ADAPTORS += dbus
DBUS_INTERFACES += dbus

CONFIG(release, debug|release) {
    TRANSLATIONS = $$files($$PWD/translations/*.ts)
    #遍历目录中的ts文件，调用lrelease将其生成为qm文件
    for(tsfile, TRANSLATIONS) {
        qmfile = $$replace(tsfile, .ts$, .qm)
        system(lrelease $$tsfile -qm $$qmfile) | error("Failed to lrelease")
    }
    #将qm文件添加到安装包
    dtk_translations.path = /usr/share/$$TARGET/translations
    dtk_translations.files = $$PWD/translations/*.qm
    INSTALLS += dtk_translations
}

target.path = /usr/bin/

install_service.files = com.deepin.defender.autostart.service
install_service.path = /usr/share/dbus-1/services

INSTALLS += target install_service
