/*
 * Copyright (C) 2019 ~ 2019 Deepin Technology Co., Ltd.
 *
 * Author:     wubowen <wubowen_cm@deepin.com>
 *
 * Maintainer: wubowen <wubowen_cm@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#pragma once

#include "autostart_adaptor.h"
#include "window/modules/startup/startupmonitor.h"
#include "window/modules/startup/dbustartmanager.h"
#include "com_deepin_dde_daemon_launcherd.h"

#include <QObject>

using Launcherd = com::deepin::dde::daemon::Launcher;
class OperateDBusData : public QObject
{
    Q_OBJECT
public:
    explicit OperateDBusData(QObject *parent = nullptr);

public Q_SLOTS:
    void StartApp();
    void ExitApp();

    // 进程初始化，无需调用，随着进程启用而启用
    void initialize();
    void preInitialize();

    // 取开机自启动所有数据， 先启动launcher服务，再取值
    bool startLauncherManage();
    QString getAppsInfoEnable();
    QString getAppsInfoDisable();

    // 判断是否是开机自启
    bool isAutostart(QString sPath);

    // 执行开机自启动管理 开启/禁止操作
    bool exeAutostart(int nStatus, QString sPath);

    // 外部调用刷新表格数据
    void refreshData(bool bAdd, QString sID);
Q_SIGNALS:
    void AccessRefreshData(bool bAdd, QString sID);

private:
    AutostartAdaptor *m_adaptpr;

    StartupMonitor *m_monitor = nullptr;

    QMap<QString, QString> m_mapEnable;                     // 不允许自启动数据容器
    QMap<QString, QString> m_mapDisable;                    // 允许自启动数据容器
    QStringList m_EnableData;
    QStringList m_DisableData;
    QString m_EnableAppsInfo;
    QString m_DisableAppsInfo;

    Launcherd          *m_launcherInter     = nullptr;          // 取应用数据接口
    QDBusPendingReply<LauncherItemInfoList> m_reply;            // 应用信息接口
    DBusStartManager   *m_startManagerInterface = nullptr;      // 自启动接口
};
