/*
 * Copyright (C) 2017 ~ 2019 Deepin Technology Co., Ltd.
 *
 * Author:     wubowen <wubowen_cm@deepin.com>
 *
 * Maintainer: wubowen <wubowen_cm@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#pragma once

#include <QObject>
#include <QDBusConnection>
#include <QDBusInterface>

#include "daemonservice_adaptor.h"
#include "com_deepin_defender_daemonservice.h"
#include "com_deepin_defender_analysisapp.h"
#include "com_deepin_defender_monitornetflow.h"
#include "com_deepin_defender_trafficdetails.h"
#include "com_deepin_defender_autostart.h"
#include "com_deepin_defender_netcontrol.h"
#include "QGSettings/QGSettings"

using Analysisapp = com::deepin::defender::analysisapp;
using MonitorNetFlow = com::deepin::defender::MonitorNetFlow;
using TrafficDetails = com::deepin::defender::trafficdetails;
using Autostart = com::deepin::defender::autostart;
using Netcontrol = com::deepin::defender::netcontrol;
using DaemonService = com::deepin::defender::daemonservice;

enum LoginSecurity{high = 0, middle, low};
const QString loginSafety = "login-safety";

class ServiceDBus : public QObject
{
    Q_OBJECT
public:
    explicit ServiceDBus(QObject *parent = nullptr);
    int Charactertypes(QString password);

Q_SIGNALS:
    void UpdateUI();

public Q_SLOTS:
    void ExitApp();
    void StartApp();
    void ExitAllService();
    void ExitAnalysisService();
    void ExitAutoStartService();
    void ExitNetControlService();
    void ExitTrafficDetailService();
    void ExitMonitorNetFloService();
    void SetGsetting(int value);
    QString notifySendPassword(const QString &password);
    QString getError(LoginSecurity type);
    QString GetPwdError();
    int GetPwdLen();
    int GetPwdTypeLen();

private:
    DaemonserviceAdaptor *m_adaptor;
    Analysisapp *m_analysisapp;
    MonitorNetFlow *m_monitornetflow;
    TrafficDetails *m_trafficDetails;
    Autostart *m_autostart;
    Netcontrol *m_netcontrol;
    QGSettings *m_gset;
    DaemonService *m_daemonservice;
};
