QT += core gui dbus dtkwidget

greaterThan(QT_MAJOR_VERSION, 4): QT += widgets

TARGET = deepin-defender-netcontrol
TEMPLATE = app
CONFIG += c++11 link_pkgconfig
PKGCONFIG += gsettings-qt dframeworkdbus

SOURCES += \
    main.cpp \
    operatedbusdata.cpp \
    csingleteon.cpp \
    window/modules/networkprotection/netprowidget/networkaccesscontroldelegate.cpp \
    window/modules/networkprotection/netprowidget/funcconnnetcontrol.cpp \
    window/modules/networkprotection/networkmonitor/networkconnectmonitor.cpp \
    window/modules/networkprotection/networkprotectionmodel.cpp \
    window/modules/networkprotection/networkprotectionworker.cpp \
    window/modules/networkprotection/reminderdialog.cpp

HEADERS += \
    operatedbusdata.h \
    common.h \
    csingleteon.h \
    window/namespace.h \
    window/modules/networkprotection/netprowidget/networkaccesscontroldelegate.h \
    window/modules/networkprotection/netprowidget/funcconnnetcontrol.h \
    window/modules/networkprotection/networkmonitor/networkconnectmonitor.h \
    window/modules/networkprotection/networkprotectionmodel.h \
    window/modules/networkprotection/networkprotectionworker.h \
    window/modules/networkprotection/reminderdialog.h

dbus.files = com.deepin.defender.netcontrol.xml

DBUS_ADAPTORS += dbus
DBUS_INTERFACES += dbus

CONFIG(release, debug|release) {
    TRANSLATIONS = $$files($$PWD/translations/*.ts)
    #遍历目录中的ts文件，调用lrelease将其生成为qm文件
    for(tsfile, TRANSLATIONS) {
        qmfile = $$replace(tsfile, .ts$, .qm)
        system(lrelease $$tsfile -qm $$qmfile) | error("Failed to lrelease")
    }
    #将qm文件添加到安装包
    dtk_translations.path = /usr/share/$$TARGET/translations
    dtk_translations.files = $$PWD/translations/*.qm
    INSTALLS += dtk_translations
}

target.path = /usr/bin/

install_gsettings.files = ./schemas/com.deepin.dde.deepin-defender-netcontrol.gschema.xml
install_gsettings.path = /usr/share/glib-2.0/schemas/
install_service.files = com.deepin.defender.netcontrol.service
install_service.path = /usr/share/dbus-1/services

INSTALLS += target install_gsettings install_service

