/*
 * Copyright (C) 2019 ~ 2019 Deepin Technology Co., Ltd.
 *
 * Author:     wubowen <wubowen_cm@deepin.com>
 *
 * Maintainer: wubowen <wubowen_cm@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#pragma once

#include "netcontrol_adaptor.h"
#include "window/modules/networkprotection/networkprotectionmodel.h"
#include "window/modules/networkprotection/networkprotectionworker.h"
#include "window/modules/networkprotection/networkmonitor/networkconnectmonitor.h"
#include "window/modules/networkprotection/netprowidget/funcconnnetcontrol.h"
#include "com_deepin_defender_analysisapp.h"

#include <QObject>

using AnalysisApp = com::deepin::defender::analysisapp;
class OperateDBusData : public QObject
{
    Q_OBJECT
public:
    explicit OperateDBusData(QObject *parent = nullptr);

Q_SIGNALS:

public Q_SLOTS:
    // 接口
    void StartApp();
    void ExitApp();
    void preInitialize();
    void showFuncConnectNetControlInter(QString appNamePath);

    void setConnCunrrentIndex(int index);
    int getConnCunrrentIndex();
    void setQuitDefender(bool value);
    void setColor(QString sColor);

    // 槽
    void initialize();
    void showFuncConnectNetControl(const QStringList &appNamePath);
    void doDialogClose();

private:
    NetcontrolAdaptor *m_adaptpr;

    NetworkProtectionModel *m_model;
    NetworkProtectionWorker *m_worker;
    NetworkConnectMonitor *m_monitor;
    FuncConnNetControl *m_NetDialog = nullptr;

    AnalysisApp    *m_AnalysisAppInter = nullptr;
    QString m_sColor;
};
