/*
 * Copyright (C) 2017 ~ 2019 Deepin Technology Co., Ltd.
 *
 * Author:     caimengci <caimengci_cm@deepin.com>
 *
 * Maintainer: caimengci <caimengci_cm@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#pragma once

#include "DStyleOption"

#include <QStyledItemDelegate>
#include <DStyledItemDelegate>

class NetworkAccessControlDelegate : public DTK_WIDGET_NAMESPACE::DStyledItemDelegate
{
    Q_OBJECT
public:
    explicit NetworkAccessControlDelegate(QAbstractItemView *parent = nullptr);

    enum AppAccessControlColumn {
        ItemAppName = 0,
        ItemAsk,
        ItemAllow,
        ItemDisallow,
        ItemDefault,

        ColumnButt,
    };
    Q_ENUM(AppAccessControlColumn)

    enum ScannResultDataRole {
        ItemAppNameRole = DTK_NAMESPACE::UserRole + 1,
//        ItemAskRole,
//        ItemAllowRole,
//        ItemDisallowRole,
//        ItemDefaultRole,
        ItemAccessOptionRole,
    };

    enum NetworkAccessOption {
        DEFAULT_ASK = 0,
        DEFAULT_DISALLOW,
        DEFAULT_ALLOW,
        DEFAULT_DEFAULT
    };
private:
    void paint(QPainter *painter,
               const QStyleOptionViewItem &option, const QModelIndex &index) const override;
    bool editorEvent(QEvent *event, QAbstractItemModel *model, const QStyleOptionViewItem &option, const QModelIndex &index) override;
    int colSelectedd(const QStyleOptionViewItem &option, const QPoint &pos);
};
