/*
 * Copyright (C) 2019 ~ 2019 Deepin Technology Co., Ltd.
 *
 * Author:     caimengci <caimengci_cm@deepin.com>
 *
 * Maintainer: caimengci <caimengci_cm@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#pragma once

#include "com_deepin_daemon_aclnetwork.h"
#include "com_deepin_defender_analysisapp.h"

#include <QObject>
#include <QTimer>

using ACLNetwork = com::deepin::daemon::acl::Network;
using AnalysisApp = com::deepin::defender::analysisapp;

class OperateDBusData;
class NetworkConnectMonitor : public QObject
{
    Q_OBJECT
public:
    explicit NetworkConnectMonitor(OperateDBusData *dbus, QObject *parent = nullptr);

Q_SIGNALS:
    void requestNetworkConnet(ACLNetwork *, QString sId, QStringList sAppName);
    void registerReply();
    void reqStartTimer();

private Q_SLOTS:
    void onAppNetworkConnect(const QString &id);
    void deleteProcessDesktop();
    void onReqStartTimer();

private:
    void getDesktopName(const QString &id);

private:
    ACLNetwork *m_aclInter = nullptr;
    QMap<QString, QStringList> m_saveProcess_Desktop;
    QTimer *m_showTimer = nullptr;

    AnalysisApp *m_AnalysisAppInter = nullptr;
};
