/*
 * Copyright (C) 2019 ~ 2019 Deepin Technology Co., Ltd.
 *
 * Author:     caimengci <caimengci_cm@deepin.com>
 *
 * Maintainer: caimengci <caimengci_cm@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#pragma once

#include <DDialog>

QT_BEGIN_NAMESPACE
class QTimer;
QT_END_NAMESPACE

class ReminderDialog : public DTK_WIDGET_NAMESPACE::DDialog
{
    Q_OBJECT
public:
    explicit ReminderDialog(DDialog *parent = nullptr);
    explicit ReminderDialog(const QString &id, const QString &appName, bool ask = true, bool disable = false, DDialog *parent = nullptr);
    ~ReminderDialog() override;

    void setId(const QString &name);
    void grabMouseAndKeyboardFocus(bool bgrab = true);
    void setAsk(bool ask);
    void setDisable(bool disable);

Q_SIGNALS:
    void notifyButtonClicked(const QString &id, int);
    void notifyTimedout(const QString &id, bool ask);

private:
    void initUI();
    void mouseMoveEvent(QMouseEvent *e) override;

private:
    QString m_id;
    QString m_appName;
    QTimer *m_timer;
    bool m_ask;
    bool m_disable;
    volatile bool m_exit;
    int m_elapsedSeconds;
};
