/*
 * Copyright (C) 2019 ~ 2019 Deepin Technology Co., Ltd.
 *
 * Author:     wubowen <wubowen_cm@deepin.com>
 *
 * Maintainer: wubowen <wubowen_cm@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#pragma once

#include "trafficdetails_adaptor.h"
#include "com_deepin_defender_trafficdetails.h"
#include "defenderhandlethread.h"
#include "trafficdetailsworker.h"
#include "defenderdisplay.h"

#include <QObject>

class OperateDBusData : public QObject
{
    Q_OBJECT
public:
    explicit OperateDBusData(QObject *parent = nullptr);

Q_SIGNALS:

public Q_SLOTS:
    void StartApp();
    void ExitApp();
    void SendDisplayFlowlist(DefenderDisplayList);
    void SendDisplaySpeedlist(DefenderDisplayList);
//    void UpdateDisplay(QList<DefenderDisplay> displaylist);
    //通知获取所有应用当前时间跨度下流量数据总和
    void notifyGetYesterdayFlowData();
    void notifyGetTodayFlowData();
    void notifyGetLastMonthFlowData();
    void notifyGetThisMonthFlowData();
    //通知获取应用当前时间跨度下流量数据
    void notifyGetAppYesterdayFlowData(QString appname);
    void notifyGetAppTodayFlowData(QString appname);
    void notifyGetAppLastMonthFlowData(QString appname);
    void notifyGetAppThisMonthFlowData(QString appname);
    //向外部进程发送单个应用的数据列表
    void recAppFlowList(QList<AppFlowDateParameter> appFlowLst);

private:
    TrafficdetailsAdaptor *m_adaptor;
    DefenderHandleThread *m_handlethread;
    TrafficDetailsWorker *m_worker;
    //使用数据库
    UseData *m_useData;
};
