/*
 * Copyright (C) 2019 ~ 2019 Deepin Technology Co., Ltd.
 *
 * Author:     wubowen <wubowen_cm@deepin.com>
 *
 * Maintainer: wubowen <wubowen_cm@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#pragma once

#define USE_DEBUG 1

#if USE_DEBUG
#include "monitornetflow_adaptor.h"
#endif
#include <QObject>
#include <QThread>

const QString service = "com.deepin.defender.MonitorNetFlow";
const QString path = "/com/deepin/defender/MonitorNetFlow";
const int timeout = 3;

class WriteDBusData : public QObject
{
    Q_OBJECT
public:
    explicit WriteDBusData(QObject *parent = nullptr);
    ~WriteDBusData();

Q_SIGNALS:
    void notifyDBusKbData(QString, double, double, int, QString, QString);
    void notifyGlobalData(double, double);
    void notifyWorking();

public Q_SLOTS:
    void onNotifyDBusData(QString name, double recv_value, double send_value, int pid, QString device, QString type);
    void onNotifyGlobalData(double recv_value, double send_value);
    void StartApp();
    void ExitApp();
    void onNotifyHeartbeat();

private:
    double m_recv_value;
    double m_send_value;
    double global_recv_value;
    double global_send_value;
    int m_pid;
    QString m_device;
#if USE_DEBUG
    MonitorNetFlowAdaptor *m_adaptor;
#endif
};
