QT += core gui dbus charts sql dtkwidget

greaterThan(QT_MAJOR_VERSION, 4): QT += widgets

TARGET = deepin-defender
TEMPLATE = app
CONFIG += c++11 link_pkgconfig
PKGCONFIG += gsettings-qt dframeworkdbus

INCLUDEPATH += src
include($$PWD/src/window/modules/modules.pri)

SOURCES += \
        src/main.cpp \
        src/window/interface/moduleinterface.cpp \
        src/window/mainwindow.cpp \
        src/widgets/scorebar.cpp \
        src/widgets/fixitemwindow.cpp \
        src/widgets/scoreprogressbar.cpp \
        src/widgets/securitylevelitem.cpp \
        src/csingleteon.cpp \
        settings_translation.cpp \
        src/widgets/basiclistdelegate.cpp \
        src/widgets/dccslider.cpp \
        src/widgets/dccsliderannotated.cpp \
        src/widgets/titledslideritem.cpp \
        src/widgets/settingsitem.cpp \
        src/widgets/basiclistmodel.cpp \
        src/widgets/settingsgroup.cpp \
        src/widgets/settingsheaderitem.cpp \
        src/widgets/translucentframe.cpp \
        src/widgets/titlelabel.cpp \
        src/widgets/titlebuttonitem.cpp \
        src/defenderdbusservice.cpp \
        src/widgets/switchwidget.cpp

HEADERS += \
        src/window/namespace.h \
        src/window/interface/frameproxyinterface.h \
        src/window/interface/moduleinterface.h \
        src/window/mainwindow.h \
        src/window/utils.h \
        src/widgets/scorebar.h \
        src/widgets/fixitemwindow.h \
        src/widgets/scoreprogressbar.h \
        src/widgets/securitylevelitem.h \
        src/csingleteon.h \
        src/widgets/basiclistdelegate.h \
        src/widgets/dccslider.h \
        src/widgets/dccsliderannotated.h \
        src/widgets/titledslideritem.h \
        src/widgets/settingsitem.h \
        src/widgets/basiclistmodel.h \
        src/widgets/labels/normallabel.h \
        src/widgets/settingsgroup.h \
        src/widgets/settingsheaderitem.h \
        src/widgets/translucentframe.h \
        src/widgets/titlelabel.h \
        src/widgets/titlebuttonitem.h \
        src/widgets/labels/tipslabel.h \
        src/widgets/labels/smalllabel.h \
        src/widgets/labels/largelabel.h \
        src/defenderdbusservice.h \
        src/widgets/switchwidget.h

isEmpty(PREFIX){
    PREFIX = /usr
}

CONFIG(release, debug|release) {
    message("current dir:" + $$PWD)
    TRANSLATIONS = $$files($$PWD/translations/*.ts)
    #遍历目录中的ts文件，调用lrelease将其生成为qm文件
    for(tsfile, TRANSLATIONS) {
        qmfile = $$replace(tsfile, .ts$, .qm)
        system(lrelease $$tsfile -qm $$qmfile) | error("Failed to lrelease")
    }
    #将qm文件添加到安装包
    dtk_translations.path = /usr/share/$$TARGET/translations
    dtk_translations.files = $$PWD/translations/*.qm
    INSTALLS += dtk_translations
}

dbus.files = com.deepin.defender.hmiscreen.xml

DBUS_ADAPTORS += dbus
DBUS_INTERFACES += dbus

target.path = $${PREFIX}/bin/

install_gsettings.files = ./schemas/*.gschema.xml
install_gsettings.path = $${PREFIX}/share/glib-2.0/schemas/

install_desktop.files = ./deepin-defender.desktop
install_desktop.path = $${PREFIX}/share/applications

#install_autostart.files = ./deepin-defender.desktop
#install_autostart.path = /etc/xdg/autostart/

install_qm.files = ./translations/*.qm
install_qm.path = $${PREFIX}/share/deepin-defender/translations

install_service.files = ./com.deepin.defender.hmiscreen.service
install_service.path = $${PREFIX}/share/dbus-1/services

install_docs.files = ./docs/*
install_docs.path = $${PREFIX}/share/dman/deepin-denfender

icon.path = /usr/share/icons/hicolor/scalable/apps
icon.files = $$PWD/src/window/icons/icons/deepin-defender.svg

INSTALLS += target install_gsettings install_desktop install_autostart install_qm install_service install_docs icon

RESOURCES += \
    src/window/icons/defender_icons.qrc \
    src/window/modules/networkprotection/imageresource.qrc \
    defender.qrc

system($$DTK_SETTINGS -o settings_translation.cpp $$PWD/dt-settings.json)
