/*
 * Copyright (C) 2017 ~ 2019 Deepin Technology Co., Ltd.
 *
 * Author:     LiLinling <lilinling_cm@deepin.com>
 *
 * Maintainer: LiLinling <lilinling_cm@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include "window/namespace.h"

#include "dtkwidget_global.h"

#include <QWidget>

class CircleLabel;

DWIDGET_BEGIN_NAMESPACE
class DSuggestButton;
class DTipLabel;
DWIDGET_END_NAMESPACE

QT_BEGIN_NAMESPACE
class QHBoxLayout;
class QLabel;
class QCheckBox;
QT_END_NAMESPACE

DEF_NAMESPACE_BEGIN
DEF_ANTIVIRUS_NAMESPACE_BEGIN
class VirusModel;
class AntiVirusMainWidget : public QWidget
{
    Q_OBJECT
public:
    explicit AntiVirusMainWidget(QWidget *parent = nullptr);
    void setModel(VirusModel *model);

    Q_SIGNALS:
    void requestStartScan(int type);

private Q_SLOT:
    void onScanBtnClicked();

private:
    QHBoxLayout *m_centralLayout;
    VirusModel *m_model;
    QLabel *m_daysPassed;
    QCheckBox *m_cb1, *m_cb2;
    DTK_WIDGET_NAMESPACE::DSuggestButton *m_scanBtns;
    CircleLabel *m_engineBtn;
    QLabel *m_libVersionTime;
    DTK_WIDGET_NAMESPACE::DTipLabel *m_libstatus;
    QString m_virusVersion;
    QString m_virusDate;
};
DEF_ANTIVIRUS_NAMESPACE_END
DEF_NAMESPACE_END
