/*
 * Copyright (C) 2017 ~ 2019 Deepin Technology Co., Ltd.
 *
 * Author:     LiLinling <lilinling_cm@deepin.com>
 *
 * Maintainer: LiLinling <lilinling_cm@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#include "antivirusmodule.h"
#include "antivirusmainwidget.h"
#include "virusscanningwidget.h"
#include "virusscanresultwidget.h"
#include "scanworker.h"
#include "virusmodel.h"

DEF_USING_NAMESPACE
DEF_USING_ANTIVIRUS_NAMESPACE

AntiVirusModule::AntiVirusModule(FrameProxyInterface *frameProxy, QObject *parent)
    : QObject(parent)
    , ModuleInterface(frameProxy)
    , m_model(new VirusModel)
    , m_worker(new ScanWorker(m_model, ""))
{
}

void AntiVirusModule::preInitialize()
{

}

void AntiVirusModule::initialize()
{

}

const QString AntiVirusModule::name() const
{
    return "antivirus";
}

void AntiVirusModule::active()
{
    AntiVirusMainWidget *w = new AntiVirusMainWidget;
    w->setModel(m_model);
    connect(w, &AntiVirusMainWidget::requestStartScan, this, [=] {
        VirusScanningWidget *scanning = new VirusScanningWidget(m_worker, 1, w);
        m_frameProxy->pushWidget(this, scanning);
        connect(scanning, &VirusScanningWidget::requestScanResultWidget, this, [=] {
           VirusScanResultWidget *scanResult = new VirusScanResultWidget;
           connect(scanResult, &VirusScanResultWidget::requestBack, this, [=] {
               m_frameProxy->popWidget(this);
           });
           m_frameProxy->pushWidget(this, scanResult);
        });
    });

    m_frameProxy->pushWidget(this, w);
}

void AntiVirusModule::deactive()
{

}
