/*
 * Copyright (C) 2017 ~ 2019 Deepin Technology Co., Ltd.
 *
 * Author:     LiLinling <lilinling_cm@deepin.com>
 *
 * Maintainer: LiLinling <lilinling_cm@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef CIRCLELABEL_H
#define CIRCLELABEL_H

#include <QWidget>

class CircleLabel : public QWidget
{
    Q_OBJECT
public:
    explicit CircleLabel(QWidget *parent = nullptr);
    explicit CircleLabel(const QString &text, QColor color, QWidget *parent = nullptr);
    explicit CircleLabel(QPixmap pixmap, bool hasLine, QWidget *parent = nullptr);
    void setText(const QString &text, QColor color);
    void setPixmap(QPixmap pixmap, QColor color);
    void setSimplePixmap(QPixmap pixmap);
    void setValue(int value);

private:
    void paintEvent(QPaintEvent *event) override;
    void drawCircle(QPainter *painter, int radius);
    void drawArc(QPainter *painter, int radius);

private:
    QColor m_color;
    QColor m_progressColor;
    QString m_txt;
    QPixmap m_pixmap;
    int m_value;
    bool m_isTxt;
    bool m_hasLine;
    int m_lineWidth;

};

#endif // CIRCLELABEL_H
