/*
 * Copyright (C) 2017 ~ 2019 Deepin Technology Co., Ltd.
 *
 * Author:     LiLinling <lilinling_cm@deepin.com>
 *
 * Maintainer: LiLinling <lilinling_cm@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#pragma once

#include "window/namespace.h"

#include <QObject>

QT_BEGIN_NAMESPACE
class QGSettings;
QT_END_NAMESPACE

DEF_NAMESPACE_BEGIN
class VirusModel : public QObject
{
    Q_OBJECT
public:
    explicit VirusModel(QObject *parent = nullptr);
    qint64 lastAntiVirusDays();
    void setLastAntiVirusDays(const QDate &date);
    QString virusVersion();
    void setVirusVersion(const QString &version);
    QString virusDate();
    void setVirusDate(const QString &date);
    QString latestVersion();
    void setLatestVersion(const QString &version);

Q_SIGNALS:
    void lastAntiVirusDaysChanged(qint64 days);
    void currentVirusVersionChanged(const QString &ver);
    void currentVirusDateChanged(const QString &date);
    void latestVersionChanged(const QString &ver);

private:
    QGSettings *m_gs;
    QString m_lastAntiVirusDate;
    QString m_currentVirusVersion;
    QString m_currentVirusDate;
    QString m_latestVersion;
};
DEF_NAMESPACE_END
