/*
 * Copyright (C) 2017 ~ 2019 Deepin Technology Co., Ltd.
 *
 * Author:     LiLinling <lilinling_cm@deepin.com>
 *
 * Maintainer: LiLinling <lilinling_cm@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#pragma once

#include "dtkwidget_global.h"

#include <QWidget>

class CircleLabel;
class ScanWorker;

DWIDGET_BEGIN_NAMESPACE
class DTipLabel;
class DListView;
DWIDGET_END_NAMESPACE

QT_BEGIN_NAMESPACE
class QLabel;
class QProgressBar;
class QPushButton;
class QTableView;
class QVBoxLayout;
class QStandardItemModel;
class QDir;
class QThread;
QT_END_NAMESPACE

class VirusScanningWidget : public QWidget
{
    Q_OBJECT
public:
    explicit VirusScanningWidget(ScanWorker *worker, int scanType, QWidget *parent = nullptr);
    void onAddItem(const QString &itemName, const QString &itemStatics, const QString &itemState, int type = 0);
    void scanDir(QDir &dir);

private:
    void updateUsedTime(int progress = 100);

Q_SIGNALS:
    void requestScanResultWidget();
    void operate(const QString &);

private Q_SLOTS:
    void onProgress(int value, int type, const QString &itemInfo);

private:
    QVBoxLayout *m_centralLayout;
    CircleLabel *m_usedTime;
    QLabel *m_scanning;
    DTK_WIDGET_NAMESPACE::DTipLabel *m_abnormalTxt;
    QProgressBar *m_progressBar;
    QLabel *m_scanDetailTxt;
    QPushButton *m_stopBtn;
    QLabel *m_predictedTime;
    QLabel *m_line;
    DTK_WIDGET_NAMESPACE::DListView *m_tb;
    QStandardItemModel *m_scanedModel;
    QThread *m_scanThread;
    ScanWorker *m_worker;
    qint64 m_startTime;
    bool m_isScanning;
    int m_abnormalCnt;
    int m_total;
    int m_progress;
    qint64 m_lastUpdateTime;
};
