/*
 * Copyright (C) 2017 ~ 2019 Deepin Technology Co., Ltd.
 *
 * Author:     LiLinling <lilinling_cm@deepin.com>
 *
 * Maintainer: LiLinling <lilinling_cm@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#pragma once

#include <DStyleOption>
#include <QStyledItemDelegate>

class VirusScanResultItemDelegate : public QStyledItemDelegate
{
    Q_OBJECT
public:
    enum ScannResultColumn {
        ItemCheck = 0,
        ItemName,
        ItemDesc,
        ItemState,

        ColumnButt,
    };
    Q_ENUM(ScannResultColumn)

    enum ScannResultDataRole {
        ItemCheckRole = DTK_NAMESPACE::UserRole + 1,
        ItemNameRole,
        ItemDescRole,
        ItemStateRole,
        ItemLevelRole,
        ItemSummaryRole,
    };

    enum ItemLevel {
        NORMAL = 0,
        SUMMARY_DANGEROUS,
        SUMMARY_FATAL,
        DANGEROUS,
        FATAL,
    };

    explicit VirusScanResultItemDelegate(QWidget *parent = nullptr);

private:
    virtual void initStyleOption(QStyleOptionViewItem *option, const QModelIndex &index) const override;
    void paint(QPainter *painter, const QStyleOptionViewItem &option, const QModelIndex &index) const override;
    bool editorEvent(QEvent *event, QAbstractItemModel *model,
                     const QStyleOptionViewItem &option, const QModelIndex &index) override;
};

