/*
 * Copyright (C) 2017 ~ 2019 Deepin Technology Co., Ltd.
 *
 * Author:     LiLinling <lilinling_cm@deepin.com>
 *
 * Maintainer: LiLinling <lilinling_cm@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef VIRUSSCANRESULTWIDGET_H
#define VIRUSSCANRESULTWIDGET_H

#include "dtkwidget_global.h"

#include <QWidget>
#include <QMap>

class CircleLabel;

DWIDGET_BEGIN_NAMESPACE
class DSuggestButton;
class DListView;
DWIDGET_END_NAMESPACE

QT_BEGIN_NAMESPACE
class QLabel;
class QPushButton;
class QStandardItemModel;
class QStandardItem;
QT_END_NAMESPACE

class VirusScanResultWidget : public QWidget
{
    Q_OBJECT
public:
    explicit VirusScanResultWidget(QWidget *parent = nullptr);

private:
    void onAddItem(bool hasCheck, bool isChecked, const QString &name, const QString &desc, const QString &state, int type);
    void onAddSummary(const QString &summary);
    void updateSummary(const QString &summary);

Q_SIGNALS:
    void requestBack();

private:
    CircleLabel *m_resultIcon;
    QLabel *m_totalTxt;
    QPushButton *m_backBtn;
    DTK_WIDGET_NAMESPACE::DSuggestButton *m_handleBtn;
    QLabel *m_detailTxt;
    QLabel *m_line;
    DTK_WIDGET_NAMESPACE::DListView *m_tb;
    QStandardItemModel *m_model;
    int m_fatalCnt;
    int m_dangerousCnt;
    QMap<int, QStandardItem *> m_summaryMap;
};

#endif // VIRUSSCANRESULTWIDGET_H
