/*
 * Copyright (C) 2019 ~ 2019 Deepin Technology Co., Ltd.
 *
 * Author:     caitao <caitao@deepin.com>
 *
 * Maintainer: caitao <caitao@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef EXAMWORKER_H
#define EXAMWORKER_H

#include "window/modules/homepage/homepagework.h"

#include <QObject>

class ExamWorker : public QObject
{
    Q_OBJECT
    enum Status {running, paused, quitted};
public:
    explicit ExamWorker(QObject *parent = nullptr);
    ~ExamWorker();

    void setModelAndWork(HomePageModel *mode, HomePageWork *work) {m_mode = mode; m_work = work;}
    void run();
    void pause();
    void resume();
    void quit();
    void waitWithStatus(int mSec); //随运行状态对线程进行等待

private:
    void judgeStatus();
    double examiningSafetyLevel();
    double examiningAntivirus();
    double examiningNetProtect();

Q_SIGNALS:
    void sendExamineProcess(QString place, int fixItemId); //发送当前扫描的位置

public Q_SLOTS:
    void examining();


private:
    HomePageModel *m_mode;
    HomePageWork *m_work;
    Status m_status;
    int m_score;
};

#endif // EXAMWORKER_H
