/*
 * Copyright (C) 2019 ~ 2019 Deepin Technology Co., Ltd.
 *
 * Author:     caitao <caitao@deepin.com>
 *
 * Maintainer: caitao <caitao@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef HOMEPAGEMODULE_H
#define HOMEPAGEMODULE_H

#include "window/interface/moduleinterface.h"
#include "window/interface/frameproxyinterface.h"
#include "window/modules/homepage/homepagemodel.h"
#include "window/modules/homepage/homepagework.h"
#include "window/modules/homepage/homepagewidget.h"
#include "window/modules/homepage/examdetailpage.h"

DEF_NAMESPACE_BEGIN
class FrameProxyInterface;
class ModuleInterface;
DEF_ANTIVIRUS_NAMESPACE_BEGIN
class HomePageModule : public QObject, public ModuleInterface
{
    Q_OBJECT
public:
    explicit HomePageModule(FrameProxyInterface *frame, QObject *parent = nullptr);
    ~HomePageModule() override {}

public:
    void initialize() override;
    void preInitialize() override;
    const QString name() const override;
    void active() override;
    void deactive() override;

Q_SIGNALS:
    void requestShowSafetyLevelWidgt(); //把信号推到mainwindow

public Q_SLOTS:
    void showScoreDetailPage(QList<int> fixItemIdLst);

private:
    HomePageModel *m_homePageModel;
    HomePageWork *m_homePageWork;
    HomePageWidget *m_homePageWidget;
    ExamDetailPage *m_examDetailPage;
    bool m_isbExamining{false};

};

#endif // HOMEPAGEMODULE_H
DEF_ANTIVIRUS_NAMESPACE_END
DEF_NAMESPACE_END
