/*
 * Copyright (C) 2019 ~ 2019 Deepin Technology Co., Ltd.
 *
 * Author:     caitao <caitao@deepin.com>
 *
 * Maintainer: caitao <caitao@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include "window/namespace.h"
#include "dtkwidget_global.h"
#include "window/interface/frameproxyinterface.h"
#include "window/interface/moduleinterface.h"
#include "window/modules/homepage/homepagework.h"
#include "window/modules/homepage/examdetailpage.h"
#include "window/modules/homepage/examworker.h"

#include <DSuggestButton>
#include <DTipLabel>

#include <QWidget>
#include <QPushButton>

DWIDGET_BEGIN_NAMESPACE
class DSuggestButton;
DWIDGET_END_NAMESPACE

QT_BEGIN_NAMESPACE
class QHBoxLayout;
class QLabel;
class QPushButton;
QT_END_NAMESPACE

DEF_NAMESPACE_BEGIN
DEF_ANTIVIRUS_NAMESPACE_BEGIN

DWIDGET_USE_NAMESPACE

class HomePageWidget : public QWidget
{
    Q_OBJECT
public:
    enum ExamineFlag {normal, examining, pause};
public:
    explicit HomePageWidget(QWidget *parent = nullptr);
    ~HomePageWidget();

    void setModelAndWork(HomePageModel *mode, HomePageWork *work);
    void updateUI();
    void reExamine();
private:

Q_SIGNALS:
    void requestShowScoreDetailPage(QList<int> fixItemIdLst);

public Q_SLOTS:
    void examineUpdate( QString place, int fixItem = 0); //系统体检

private:
    HomePageModel *m_mode;
    HomePageWork *m_work;
    QThread *m_examThread;
    ExamWorker *m_examWorker;
    QLabel *m_scoreTipLeft;
    QLabel *m_scoreTipRight;
    DTipLabel *m_examTip;
    DSuggestButton *m_examBtn;
    ExamineFlag m_examineFlag{normal};
    QList<int> m_fixItemIdLst;
};

DEF_ANTIVIRUS_NAMESPACE_END
DEF_NAMESPACE_END
