/*
 * Copyright (C) 2019 ~ 2019 Deepin Technology Co., Ltd.
 *
 * Author:     caitao <caitao@deepin.com>
 *
 * Maintainer: caitao <caitao@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#include "homepagework.h"

#include <QDateTime>

HomePageWork::HomePageWork(HomePageModel *model, QObject *parent)
    : QObject(parent)
    , m_model(model)
{
    m_gs = m_model->m_gs;
}

void HomePageWork::setSafetyScore(int score)
{
    m_gs->set(GSettingsSafetyScore, score);
}

void HomePageWork::setSafetyLevel(int level)
{
    m_gs->set(GSettingsSafetyLevel, level);
}

void HomePageWork::setLocalVer(QString ver)
{
    m_gs->set(GSettingsLocalVer, ver);
}

void HomePageWork::setLatestVer(QString ver)
{
    m_gs->set(GSettingsLatestVer, ver);
}

void HomePageWork::setLastCheckTime(QDateTime time)
{
    QString timeStr = time.toString("yyyy-MM-dd-hh-mm-ss");
    m_gs->set(GSettingsLastCheckTime, timeStr);
}
