/*
 * Copyright (C) 2019 ~ 2019 Deepin Technology Co., Ltd.
 *
 * Author:     caitao <caitao@deepin.com>
 *
 * Maintainer: caitao <caitao@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include "window/namespace.h"
#include "dtkwidget_global.h"
#include "window/modules/homepage/homepagemodel.h"

#include <QGSettings>

DEF_NAMESPACE_BEGIN
DEF_ANTIVIRUS_NAMESPACE_BEGIN

class HomePageWork : public QObject
{
    Q_OBJECT
public:
    explicit HomePageWork(HomePageModel *model,QObject *parent = nullptr);

Q_SIGNALS:

public Q_SLOTS:

public:
    void setSafetyScore(int score); //设置当前系统安全评分
    void setSafetyLevel(int level);
    void setLocalVer(QString ver);
    void setLatestVer(QString ver);
    void setLastCheckTime(QDateTime time);

private:
    HomePageModel *m_model;
    QGSettings *m_gs;
};

DEF_ANTIVIRUS_NAMESPACE_END
DEF_NAMESPACE_END
