/*
 * Copyright (C) 2019 ~ 2019 Deepin Technology Co., Ltd.
 *
 * Author:     luokai <luokai_cm@deepin.com>
 *
 * Maintainer: luokai <luokai_cm@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#pragma once

#include "window/interface/moduleinterface.h"
#include "window/interface/frameproxyinterface.h"
#include "networkprotectionworker.h"
#include "com_deepin_defender_trafficdetails.h"
#include "appdatadetaildialog.h"

#include <DButtonBox>
#include <DTipLabel>
#include <DCommandLinkButton>
#include <DBackgroundGroup>
#include <DFrame>

#include <QItemDelegate>
#include <QStandardItemModel>
#include <QTableView>

DWIDGET_USE_NAMESPACE

#define FlowWidget_Debug 1

class FlowWidget;
class FlowItemDelegate: public QItemDelegate
{
    Q_OBJECT
public:
    FlowItemDelegate(FlowWidget *widget = nullptr, QObject *parent = nullptr);
    virtual ~ FlowItemDelegate() {}

    void paint(QPainter *painter,
               const QStyleOptionViewItem &option,
               const QModelIndex &index) const;

private:
    QPixmap m_pixmap;
    FlowWidget *m_widget;
};

class NetworkProtectionModel;
class NetworkProtectionWorker;
class FlowWidget : public DFrame
{
    Q_OBJECT
public:
    explicit FlowWidget(NetworkProtectionModel *model = nullptr,
                        NetworkProtectionWorker *worker = nullptr, QWidget *parent = nullptr);
    QPixmap getPixmap(QPixmap);
Q_SIGNALS:
    void notifyflowName(QString name);

public Q_SLOTS:
    //更新界面
    void onsetdata();
    void onGetlist(int logicalIndex);
    void onUpdateLauncherList();
    void onShowDataDetailDialog(QString sName);

private:
    void SetFlowAttributes();
    void DrawFlowItem();
    void SetFLow(DefenderDisplay *showflow);

private:
    NetworkProtectionModel *m_model;
    NetworkProtectionWorker *m_worker;
    QVBoxLayout *m_layout;
    DFrame *m_tableflowdrame;//圆角widget
    QVBoxLayout *m_tableflowlayout;
    QTableView *m_flowtableview;
    QStandardItemModel *m_flowitemmodel;
    FlowItemDelegate *m_flowitem;
    FlowRangeStyle m_flowRangeStyle;
    DefenderDisplayList m_flowlist;
    DefenderDisplayList m_displaylist;
    DefenderDisplayList m_updateflowlist;
    DefenderDisplay m_showflow;
    bool m_updateflag = false;
    DefenderDisplayList m_displayflowlist;
};
DEF_NAMESPACE_END
DEF_NETPROTECTION_NAMESPACE_END
