/*
 * Copyright (C) 2019 ~ 2019 Deepin Technology Co., Ltd.
 *
 * Author:     wubowen <wubowen_cm@deepin.com>
 *
 * Maintainer: wubowen <wubowen_cm@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#pragma once

#include "window/interface/moduleinterface.h"
#include "window/interface/frameproxyinterface.h"
#include "com_deepin_defender_netcontrol.h"

#include <QWidget>

QT_BEGIN_NAMESPACE
class QVBoxLayout;
class QHBoxLayout;
class QLabel;
class QPushButton;
QT_END_NAMESPACE

DEF_NAMESPACE_BEGIN
DEF_NETPROTECTION_NAMESPACE_BEGIN

//第一个版本屏蔽未完成的功能入口
#define bIs_Complete 0

const int leftSpace = 34;

enum WidgetType {
    Default = -1,
    FuncConnectNetControl,
    NetworkLog,
    ProfessionMode,
    Count
};

using NetControlServer = com::deepin::defender::netcontrol;
class NetworkProtectionModel;
class NetworkProtectionWorker;
class TrafficDetailWidget;
class NetworkProtectionWidget : public QWidget
{
    Q_OBJECT
public:
    explicit NetworkProtectionWidget(NetworkProtectionModel *model = nullptr,
                                     NetworkProtectionWorker *worker = nullptr, QWidget *parent = nullptr);
    TrafficDetailWidget *gettrafficdetailwidget()
    {
        return widget;
    }

Q_SIGNALS:
    void notifyShowNetFlowMonitor();

private:
    void initUI();
    QVBoxLayout *initMenu();
    QHBoxLayout *initBottomButton();
    void displayWidget(QModelIndex index);
    void showFuncConnectNetControl(const QStringList &appNamePath);
    void showNetworkLog();
    void showProfessionMode();

protected:
    bool eventFilter(QObject *obj, QEvent *event);

private:
    QHBoxLayout *m_mainLayout;
    QVBoxLayout *m_layout;
    NetworkProtectionModel *m_model;
    NetworkProtectionWorker *m_worker;
    TrafficDetailWidget *widget;
    NetControlServer  *m_NetControlServerInter = nullptr; // 联网管控接口
};

DEF_NAMESPACE_END
DEF_NETPROTECTION_NAMESPACE_END
