/*
 * Copyright (C) 2019 ~ 2019 Deepin Technology Co., Ltd.
 *
 * Author:     luokai <luokai_cm@deepin.com>
 *
 * Maintainer: luokai <luokai_cm@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include "window/interface/moduleinterface.h"
#include "window/interface/frameproxyinterface.h"
#include "../systemsafetymodel.h"
#include "../systemsafetywork.h"
#include "widgets/securitylevelitem.h"
#include "dbususermanager.h"

#include <QVBoxLayout>
#include <QHBoxLayout>
#include <QStandardItemModel>
#include <QButtonGroup>
#include <QRadioButton>
#include "passwordmenu.h"

#include <DFrame>

DWIDGET_USE_NAMESPACE
class LoginSecurityWidget : public QWidget
{
    Q_OBJECT
public:
    enum LoginSecurity{high = 0, middle, low};
public:
    explicit LoginSecurityWidget(SystemSafetyModel *model, SystemSafetyWork *work, QWidget *parent = nullptr);
    ~LoginSecurityWidget();
    void initui();
    void Setlastchage();
    void onButtonClicked(int button);
    void setStyle(int grade);

public Q_SLOTS:
private:
    SystemSafetyModel *m_model;
    SystemSafetyWork *m_work;
    DbususerManager *m_usermanage;
    accounts * m_accountsuser;
    QVBoxLayout *m_layout;
    QLabel *m_PasswodUpdateTips;
    QButtonGroup *m_pButtonGroup;
    SecurityLevelItem *m_highLevelItem;
    SecurityLevelItem *m_mediumLevelItem;
    SecurityLevelItem *m_lowLevelItem;
    PassWordMenu *m_menu;
    int m_day = 0;
};
